package com.javacodegeeks.example;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import com.atlassian.activeobjects.external.ActiveObjects;
import com.atlassian.plugin.spring.scanner.annotation.component.Scanned;
import com.atlassian.plugin.spring.scanner.annotation.imports.ComponentImport;
import com.atlassian.sal.api.transaction.TransactionCallback;

import static com.google.common.base.Preconditions.checkNotNull;

@Scanned
public class QuoteServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private static final Logger log = LoggerFactory.getLogger(QuoteServlet.class);
	
	private final ActiveObjects ao;
	
	@Autowired
	public QuoteServlet(@ComponentImport ActiveObjects ao) {
		this.ao = checkNotNull(ao);
	}

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
	}
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		final String quote = req.getParameter("quote");
		final String spaceKey = req.getParameter("spaceKey");
		
		log.warn("====== \n Quote: {} \n ======", quote);
		
		ao.executeInTransaction(new TransactionCallback<Quote>() {
			@Override
			public Quote doInTransaction() {
				final Quote q = ao.create(Quote.class);
				q.setQuote(quote);
				q.save();

				return q;
			}
		});
		
		res.sendRedirect(req.getContextPath() + "/plugins/space-admin/sas.action?key=" + spaceKey);
	}
}
